#cs ----------------------------------------------------------------------------
	
	AutoIt-Version: 3.2.5.1
	Autor:         Johannes Mitlmeier & PC Magazin
	
	Skriptfunktion:
	IOM3
	
#ce ----------------------------------------------------------------------------


#RequireAdmin


If Not (@OSVersion = "WIN_VISTA" Or @OSVersion = "WIN_2003" Or @OSVersion = "WIN_XP") Then _
		MsgBox(0, "Fehler", "Die Install-O-Matic luft nur unter Windows XP und Windows Vista!")


Opt("GUIOnEventMode", 1)
Opt("ExpandVarStrings", 1)

#include <GUIConstants.au3>
#include <GUIList.au3>
#include <GUITreeView.au3>
#include <GUITab.au3>
#include <File.au3>
#include <Array.au3>
#include <String.au3>
#include "funktionen.au3"

; Globale Variablen vordefinieren
Global $version = "3.02"
Global $array_programme[6][100][4]
Global $counter[6] = [0, 0, 0, 0, 0, 0]
Global $nachgeladen = 0
Global $installation_laeuft = 0
Global $punkte = 0
Global $version = StringLeft(@ScriptName, 4)

; Temp-Fix, um aktuelle Start.exe zu holen
If _IstOnline() Then
	InetGet($update_server[0] & "updates/Start.exe", @ScriptDir & "\Start.exe", 1, 1)
EndIf

; GUI aufbauen
#Region ### START Koda GUI section ### Form=c:\iom\iom3\sonstiges\gui.kxf
$iom3 = GUICreate("Install-O-Matic $version$      (c) 2007 Johannes Mitlmeier fr PC Magazin", 633, 585, 193, 115)
$optionen = GUICtrlCreateGroup(" Optionen ", 448, 283, 177, 153)
$chk_blockinput = GUICtrlCreateCheckbox("Nutzereingaben verhindern", 456, 303, 153, 17)
GUICtrlSetTip(-1, "Sollen Maus und Tastatur whrend der Installtion deaktiviert werden?", "Erklrung", 1)
GUICtrlSetOnEvent(-1,"_BlockinpWarning")
$chk_log = GUICtrlCreateCheckbox("Log-Datei speichern", 456, 320, 153, 17)
GUICtrlSetTip(-1, "Soll die Log-Datei am Ende der Installation gespeichert werden?", "Erklrung", 1)
$chk_offline = GUICtrlCreateCheckbox("keine Daten nachladen", 456, 337, 161, 17)
GUICtrlSetTip(-1, "Soll grundstzlich verhindert werden, dass neue Installationsdateien aus dem Internet bezogen werden?", "Erklrung", 1)
$chk_kein_nst = GUICtrlCreateCheckbox("Kein Neustart", 456, 354, 153, 17)
GUICtrlSetTip(-1, "Soll der Neustart nach Beendigung aller Installationen unterdrckt werden?", "Erklrung", 1)
$chk_install_verz = GUICtrlCreateCheckbox("Installationsverzeichnis:", 456, 375, 153, 17)
GUICtrlSetTip(-1, "Soll versucht werden, alle Programme in ein bestimmtes Verzeichnis zu installieren?", "Erklrung", 1)
GUICtrlSetOnEvent(-1, "_installationsverzeichnis_an_aus")
$Input1 = GUICtrlCreateInput(@ProgramFilesDir, 457, 395, 125, 21)
GUICtrlSetTip(-1, "Installationsverzeichnis", "Erklrung", 1)
$Button1 = GUICtrlCreateButton("...", 585, 395, 36, 20, 0)
GUICtrlSetOnEvent(-1, "_installationsverzeichnis")
GUICtrlSetTip(-1, "Installationsverzeichnis whlen...", "Erklrung", 1)

$details = GUICtrlCreateGroup(" Details ", 448, 8, 177, 273)
$edt_details = GUICtrlCreateEdit("", 458, 28, 157, 243, $ES_READONLY)
GUICtrlSetTip(-1, "Details zum links ausgewhlten Programm", "Erklrung", 1)

$installationen = GUICtrlCreateGroup(" Verfgbare Programme ", 8, 8, 433, 273, -1, $WS_EX_TRANSPARENT)
$tabsheet = GUICtrlCreateTab(15, 33, 418, 240)
$TabSheet1 = GUICtrlCreateTabItem("Grundlagen")
Dim $TreeView[6]
$TreeView[1] = GUICtrlCreateTreeView(24, 64, 401, 201, $TVS_CHECKBOXES)
GUICtrlSetState(-1, $GUI_SHOW)
$TabSheet2 = GUICtrlCreateTabItem("Internet")
$TreeView[2] = GUICtrlCreateTreeView(24, 64, 401, 201, $TVS_CHECKBOXES)
$TabSheet3 = GUICtrlCreateTabItem("Tools")
$TreeView[3] = GUICtrlCreateTreeView(24, 64, 401, 201, $TVS_CHECKBOXES)
$TabSheet4 = GUICtrlCreateTabItem("Office")
$TreeView[4] = GUICtrlCreateTreeView(24, 64, 401, 201, $TVS_CHECKBOXES)
$TabSheet5 = GUICtrlCreateTabItem("Sicherheit")
$TreeView[5] = GUICtrlCreateTreeView(24, 64, 401, 201, $TVS_CHECKBOXES)
GUICtrlCreateTabItem("")
$pcm_pic = GUICtrlCreatePic(@ScriptDir & "\Sonstiges\pcmlogo.gif", 8, 288, 432, 97, BitOR($SS_NOTIFY, $WS_GROUP))
GUICtrlSetOnEvent(-1, "_homepage")
GUICtrlSetTip(-1, "Besuchen Sie das PC Magazin online!", "Erklrung", 1)
GUICtrlSetCursor($pcm_pic, 0)
$log = GUICtrlCreateGroup(" Fortschritt ", 8, 440, 617, 105)
$LogList = GUICtrlCreateList("", 14, 455, 574, 84, $LBS_NOTIFY + $WS_VSCROLL + $LBS_NOSEL)
$log_speichern = GUICtrlCreateButton("", 592, 456, 25, 81, $BS_BITMAP)
GUICtrlSetImage($log_speichern, @ScriptDir & "\Sonstiges\save.bmp")
GUICtrlSetTip(-1, "Log in eine Datei speichern...", "Erklrung", 1)
GUICtrlSetOnEvent(-1, "_LogSpeichern")
GUICtrlCreateGroup("", -99, -99, 1, 1)
$beenden = GUICtrlCreateButton("&Beenden", 528, 552, 97, 25, 0)
GUICtrlSetTip(-1, "Install-O-Matic 3 beenden...", "Erklrung", 1)
GUICtrlSetOnEvent(-1, "_beenden")
$start = GUICtrlCreateButton("Installation &starten!", 140, 392, 193, 33, 0)
GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
GUICtrlSetTip(-1, "Startet die oben ausgewhlten Installationen...", "Erklrung", 1)
GUICtrlSetOnEvent(-1, "_installieren")
GUICtrlSetCursor($start, 0)
GUISetOnEvent($GUI_EVENT_CLOSE, "_beenden")
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

; Einstellungen aus der unattended.ini bernehmen
If IniRead("@ScriptDir@\unattended.ini", "Einstellungen", "blockinput", "0") = 1 Then GUICtrlSetState($chk_blockinput, $GUI_CHECKED)
If IniRead("@ScriptDir@\unattended.ini", "Einstellungen", "log", "0") = 1 Then GUICtrlSetState($chk_log, $GUI_CHECKED)
If IniRead("@ScriptDir@\unattended.ini", "Einstellungen", "nachladen", "0") = 1 Then GUICtrlSetState($chk_offline, $GUI_CHECKED)
If IniRead("@ScriptDir@\unattended.ini", "Einstellungen", "kein_neustart", "0") = 1 Then GUICtrlSetState($chk_kein_nst, $GUI_CHECKED)
If IniRead("@ScriptDir@\unattended.ini", "Einstellungen", "installationsverzeichnis", "0") = "0" Then
	GUICtrlSetState($chk_install_verz, $GUI_UNCHECKED)
	GUICtrlSetState($Input1, $GUI_HIDE)
	GUICtrlSetState($Button1, $GUI_HIDE)
Else
	GUICtrlSetState($chk_install_verz, $GUI_CHECKED)
	GUICtrlSetState($Input1, $GUI_SHOW)
	GUICtrlSetState($Button1, $GUI_SHOW)
	GUICtrlSetData($Input1, IniRead("@ScriptDir@\unattended.ini", "Einstellungen", "installationsverzeichnis", "0"))
EndIf


Opt("WinTitleMatchMode", 4)
$taskbar_pos = WinGetPos("classname=Shell_TrayWnd")
Opt("WinTitleMatchMode", 1)

; Programme einlesen, die in dieser IOM enthalten sind
$programme = _FileListToArray(@ScriptDir & "\Installationen", "*", 2)
For $k = 1 To $programme[0]
	Switch IniRead(@ScriptDir & "\Installationen\" & $programme[$k] & "\info.ini", "Programm", "Kategorie", "-")
		Case "Grundlagen"
			$nr = 1
		Case "Internet"
			$nr = 2
		Case "Tools"
			$nr = 3
		Case "Office"
			$nr = 4
		Case "Sicherheit"
			$nr = 5
	EndSwitch
	
	$id = GUICtrlCreateTreeViewItem($programme[$k], $TreeView[$nr])
	GUICtrlSetOnEvent(-1, "_detailsAnzeigen" & $nr)
	$array_programme[$nr][$counter[$nr]][0] = $programme[$k] ; parent
	$array_programme[$nr][$counter[$nr]][1] = $programme[$k] ; child
	$array_programme[$nr][$counter[$nr]][2] = String($id) ;$id ; id
	$array_programme[$nr][$counter[$nr]][3] = "" ; special
	; Vorbelegung checken
	If IniRead(@ScriptDir & "\unattended.ini", "Vorauswahl", $programme[$k], "0") = "1" Then GUICtrlSetState($id, $GUI_CHECKED)
	$counter[$nr] += 1
	
	; Unteroptionen einblenden
	$optionen_aus_ini = IniReadSection(@ScriptDir & "\Installationen\" & $programme[$k] & "\info.ini", "Optionen")
	If Not @error Then
		$parent = $counter[$nr] - 1
		For $m = 1 To $optionen_aus_ini[0][0]
			$id = GUICtrlCreateTreeViewItem($optionen_aus_ini[$m][0], $array_programme[$nr][$parent][2])
			GUICtrlSetOnEvent(-1, "_detailsAnzeigen" & $nr)
			$array_programme[$nr][$counter[$nr]][0] = $array_programme[$nr][$counter[$nr] - 1][2] ; parent
			$array_programme[$nr][$counter[$nr]][1] = $programme[$k] ; child
			$array_programme[$nr][$counter[$nr]][2] = $id ; id
			$array_programme[$nr][$counter[$nr]][3] = $optionen_aus_ini[$m][1] ; special
			; Vorbelegung checken
			If IniRead(@ScriptDir & "\unattended.ini", "Vorauswahl", GUICtrlRead($array_programme[$nr][$counter[$nr]][0], 1) & "~" & GUICtrlRead($id, 1), "0") = "1" Then GUICtrlSetState($id, $GUI_CHECKED)
			
			$counter[$nr] += 1
		Next
		_GUICtrlTreeViewExpand($TreeView[$nr])
	EndIf
Next

AdlibEnable("_Adlib", 500)
$autostart_gemacht = 0
$start_time = TimerInit()
While 1
	Sleep(1000)
	; Autostart checken
	$autostart = IniRead("@ScriptDir@\unattended.ini", "Einstellungen", "autostart", "0")
	If $autostart <> "0" And Not $autostart_gemacht Then
		If TimerDiff($start_time) > $autostart * 1000 Then
			$autostart_gemacht = 1
			_installieren()
		EndIf
	Else
		Sleep(1000000)
	EndIf
WEnd


Func _installieren()
	
	; Log leeren
	_GUICtrlListClear($LogList)
	
	; Optionen einlesen
	$nutzer_aussperren = BitAND(GUICtrlRead($chk_blockinput), $GUI_CHECKED)
	_log("Nutzereingaben blockieren: $nutzer_aussperren$")
	$einst_log_speichern = BitAND(GUICtrlRead($chk_log), $GUI_CHECKED)
	_log("Log speichern: $einst_log_speichern$")
	$nicht_nachladen = BitAND(GUICtrlRead($chk_offline), $GUI_CHECKED)
	_log("Nichts nachladen: $nicht_nachladen$")
	$kein_neustart = BitAND(GUICtrlRead($chk_kein_nst), $GUI_CHECKED)
	_log("Kein Neustart: $kein_neustart$")
	$installationspfad_angeben = BitAND(GUICtrlRead($chk_install_verz), $GUI_CHECKED)
	If $installationspfad_angeben Then
		$installationspfad = GUICtrlRead($Input1)
		_log("Installationspfad: $installationspfad$")
		; Programmverzeichnis ndern
		$old_programfiles = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion", "ProgramFilesDir")
		RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion", "ProgramFilesDir", "Reg_SZ", _NoBackslash ($installationspfad))
	Else
		$installationspfad = "Standard"
		_log("Installationspfad: Standard")
	EndIf
	
	
	
	If $nutzer_aussperren Then BlockInput(1)
	
	$installation_laeuft = 1
	; Installationen durchgehen
	For $p = 1 To 5
		_GUICtrlTabSetCurFocus($tabsheet, $p - 1)
		
		$parent = $array_programme[$p][0][0]
		For $r = 0 To 99
			;$last_parent = $parent
			$parent = $array_programme[$p][$r][0]
			
			If $array_programme[$p][$r][0] = "" Then ExitLoop
			
			If Not StringIsDigit($parent) Then
				; Installation durchziehen
				;_log("Parent markiert: " & BitAND(GUICtrlRead($array_programme[$p][$r][2]), $GUI_CHECKED))
				If BitAND(GUICtrlRead($array_programme[$p][$r][2]), $GUI_CHECKED) Then ; markiert
					$programmname = $array_programme[$p][$r][0]
					_log("$programmname$ installieren...")
					
					; download.au3 aufrufen falls vorhanden und erlaubt
					$nachgeladen = 0
					If Not $nicht_nachladen And FileExists(@ScriptDir & "\$programmname$\download.au3") And _IstOnline () Then
						_log("Versuche, eine aktuelle Version herunterzuladen...")
						_RunScriptWait ('"@ScriptDir@\$programmname$\download.au3" run')
						$nachgeladen = 1
					EndIf
					; Parameter fr die Optionen zusammenholen
					$install_au3_parameter = ""
					;_DEBUG (StringIsDigit($array_programme[$p][$r + 1][0]))
					While StringIsDigit($array_programme[$p][$r + 1][0])
						$r += 1
						;_Log(GUICtrlRead($array_programme[$p][$r][2]))
						If BitAND(GUICtrlRead($array_programme[$p][$r][2]), $GUI_CHECKED) = 1 Then $install_au3_parameter &= $array_programme[$p][$r][3] & " "
					WEnd
					;_log($install_au3_parameter)
					
					; Installation starten falls markiert
					; If checked!
					_Splash ("Installation luft", "Installiere " & StringReplace(IniRead("@ScriptDir@\Installationen\$programmname$\info.ini", "Programm", "Name", "Unbekanntes Programm"), "&", "&&") & " " & _
							IniRead("@ScriptDir@\Installationen\$programmname$\info.ini", "Programm", "Version", ""))
					_RunScriptWait ('"@ScriptDir@\Installationen\$programmname$\install.au3" "' & _Backslash ('$installationspfad$') & '" $nachgeladen$')
					SplashOff()
					_log("$programmname$ installiert.")
				EndIf
			EndIf
		Next
	Next
	_GUICtrlTabSetCurFocus($tabsheet, 0)
	$installation_laeuft = 0
	_Adlib()
	
	If $installationspfad_angeben Then
		; Programmverzeichnis zurck
		RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion", "ProgramFilesDir", "Reg_SZ", $old_programfiles)
	EndIf
	
	_log("Aufgaben abgeschlossen.")
	If $einst_log_speichern Then
		_LogSpeichern(@TempDir & "\IOM3.log")
		ShellExecute(@TempDir & "\IOM3.log")
	EndIf
	Sleep(2000)
	
	; Neustart, wenn erwnscht
	If Not $kein_neustart Then
		$res = MsgBox(4 + 32, "Neustart?", "Soll der Computer jetzt wie geplant neugestartet werden?@CRLF@Automatischer Neustart in 10 Sekunden.", 10)
		If $res = 6 Or $res = -1 Then 
			If $einst_log_speichern Then RegWrite("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\RunOnce", "IOM3-Log", "REG_SZ", 'notepad.exe "' & @TempDir & '\IOM3.log"')
			Shutdown(2)
		EndIf
	EndIf

	If $nutzer_aussperren Then BlockInput(0)
EndFunc   ;==>_installieren


Func _detailsAnzeigen1()
	_detailsAnzeigen(1)
EndFunc   ;==>_detailsAnzeigen1
Func _detailsAnzeigen2()
	_detailsAnzeigen(2)
EndFunc   ;==>_detailsAnzeigen2
Func _detailsAnzeigen3()
	_detailsAnzeigen(3)
EndFunc   ;==>_detailsAnzeigen3
Func _detailsAnzeigen4()
	_detailsAnzeigen(4)
EndFunc   ;==>_detailsAnzeigen4
Func _detailsAnzeigen5()
	_detailsAnzeigen(5)
EndFunc   ;==>_detailsAnzeigen5

Func _BlockinpWarning()
	If GUICtrlRead($chk_blockinput) = $GUI_CHECKED Then
		MsgBox(48,"Warnung","Wenn Sie diese Option auswhlen, kann es zu Komplikationen mit AntiViren Wchtern kommen!@CRLF@Falls dies der Fall ist, knnen Sie wieder Benutzereingaben ttigen indem Sie STRG + ALT + ENTF drcken.")
	EndIf
EndFunc

Func _detailsAnzeigen($param)
	$h_item = GUICtrlSendMsg($TreeView[$param], $TVM_GETNEXTITEM, $TVGN_CARET, 0)
	If $h_item > 0 Then
		If _GUICtrlTreeViewGetParentID($TreeView[$param], $h_item) <> 0 Then
			$prog = _GUICtrlTreeViewGetText($TreeView[$param], _GUICtrlTreeViewGetParentID($TreeView[$param], $h_item))
		Else
			$prog = _GUICtrlTreeViewGetText($TreeView[$param], $h_item)
		EndIf
		;_Log($prog)
		$erg_text = ""
		$erg_text &= "Name: " & @CRLF
		$erg_text &= IniRead(@ScriptDir & "\Installationen\" & $prog & "\info.ini", "Programm", "Name", "Unbenannt") & @CRLF & @CRLF
		$erg_text &= "Version: " & @CRLF
		$erg_text &= IniRead(@ScriptDir & "\Installationen\" & $prog & "\info.ini", "Programm", "Version", "kA") & @CRLF & @CRLF
		$erg_text &= "Beschreibung: " & @CRLF
		$erg_text &= IniRead(@ScriptDir & "\Installationen\" & $prog & "\info.ini", "Programm", "Beschreibung", "nicht vorhanden") & @CRLF & @CRLF
		$erg_text &= "Autor: " & @CRLF
		$erg_text &= IniRead(@ScriptDir & "\Installationen\" & $prog & "\info.ini", "Programm", "Autor", "kein Autor bekannt") & @CRLF & @CRLF
		$erg_text &= "Homepage: " & @CRLF
		$erg_text &= IniRead(@ScriptDir & "\Installationen\" & $prog & "\info.ini", "Programm", "Homepage", "---")
		GUICtrlSetData($edt_details, $erg_text)
	EndIf
	
EndFunc   ;==>_detailsAnzeigen

Func _LogSpeichern($_file = "")
	$text = ""
	For $j = 0 To _GUICtrlListGetInfo($LogList) - 1
		$text = $text & _GUICtrlListGetText($LogList, $j) & @CRLF
	Next
	If $_file = "" Then
		$_file = FileSaveDialog("Log-Datei speichern", "::{450D8FBA-AD25-11D0-98A8-0800361B1103}", "Textdateien (*.txt)")
	EndIf
	If Not @error Then
		$write = FileOpen($_file, 2)
		FileWrite($write, $text)
		FileClose($write)
		_log("Log-Datei als " & $_file & " gespeichert.")
	EndIf
	
	;ShellExecute($_file) ; DEBUG
EndFunc   ;==>_LogSpeichern

Func _installationsverzeichnis_an_aus()
	If BitAND(GUICtrlRead($chk_install_verz), $GUI_CHECKED) = 0 Then
		GUICtrlSetState($chk_install_verz, $GUI_UNCHECKED)
		GUICtrlSetState($Input1, $GUI_HIDE)
		GUICtrlSetState($Button1, $GUI_HIDE)
	Else
		GUICtrlSetState($chk_install_verz, $GUI_CHECKED)
		GUICtrlSetState($Input1, $GUI_SHOW)
		GUICtrlSetState($Button1, $GUI_SHOW)
	EndIf
EndFunc   ;==>_installationsverzeichnis_an_aus

Func _installationsverzeichnis()
	$_ordner = FileSelectFolder("Bevorzugtes Installationsverzeichnis:", "", 1 + 2)
	If Not @error Then
		GUICtrlSetData($Input1, $_ordner)
		GUICtrlSetTip($Input1, $_ordner)
	EndIf
EndFunc   ;==>_installationsverzeichnis

Func _homepage()
	ShellExecute("http://www.pcmagazin.de")
EndFunc   ;==>_homepage

Func _log($_logtext)
	; Nachricht hinzufgen
	_GUICtrlListAddItem($LogList, $_logtext)
	; Herunterscrollen
	;_GUICtrlListSetCaretIndex($LogList, _GUICtrlListGetInfo($LogList), 0)
	ControlCommand($iom3, "", $LogList, "SelectString", $_logtext)
EndFunc   ;==>_log


Func _Adlib()
	If $installation_laeuft Then
		$punkte = Mod($punkte, 3) + 1
		_ToolTip(_StringRepeat(".", $punkte))
	Else
		ToolTip("")
	EndIf
EndFunc   ;==>_Adlib


Func _beenden()
	Exit
EndFunc   ;==>_beenden